<template>
    <vue-sticky-sidebar
        class="sidebar"
        containerSelector=".container"
        innerWrapperSelector=".sidebar__inner"
        :minWidth="767"
    >
        <div id="map-wrapper">
            <div class="map-panel">
                <div id="map_wrapper" class="canvas">
                    <GmapMap
                        :center="center"
                        :zoom="zoom"
                        ref="maps"
                        id="map_canvas"
                        class="mapping"
                        :options="options"
                    >
                        <gmap-info-window
                            :options="infoOptions"
                            :position="infoWindowPos"
                            :opened="infoWinOpen"
                            @closeclick="infoWinOpen = false"
                        >

                            <template>
                                <a target="_blank" :href="property('123456_hfsid')" class="maps-over-link sell">
                                <div style="height:75px;width:200px">
                                    <div class="container">
                                        <div class="row" >
                                    <div class="col-6" style="padding: 0px">
                                        <img
                                            src="/img/demo/property/1.jpg"
                                            class="img-fluid"
                                            style="max-width:100%"
                                        />
                                    </div>
                                    <div class="col-6">
                                        <div class="item-info">
                                            <h4 class="item-title text-center m-0">
                                                $155k
                                            </h4>

                                            <div class="item-details-i text-center" style="font-size:16px">
                                                <span
                                                    class="bedrooms"
                                                    data-toggle="tooltip"
                                                    title=""
                                                    data-original-title="3 Bedrooms"
                                                    >3 <i class="fa fa-bed"></i
                                                ></span>
                                                <span
                                                    class="bathrooms"
                                                    data-toggle="tooltip"
                                                    title=""
                                                    data-original-title="2 Bathrooms"
                                                    >2 <i class="fa fa-bath"></i
                                                ></span>
                                                <br>
                                                1000SqFt
                                            </div>
                                            <!-- <div class="item-details">
                                                <ul>
                                                    <li>
                                                        Sq Ft
                                                        <span>730-2600</span>
                                                    </li>
                                                    <li>
                                                        Type
                                                        <span>Apartments</span>
                                                    </li>
                                                </ul>
                                            </div> -->
                                        </div>
                                    </div>
                                </div>
                                    </div>
                                </div>
                                </a>
                            </template>
                            
                        </gmap-info-window>
                        <gmap-cluster>
                            <GmapMarker
                                ref="marker"
                                :key="index"
                                v-for="(m, index) in markers"
                                :position="m.position"
                                :clickable="true"
                                :draggable="true"
                                :icon="m.icon"
                                @mouseover="toggleInfoWindow(m, index)"
                                @mousedown="closeInfoWindow"
                                @click="clickInfo(m, index)"
                            />
                        </gmap-cluster>
                    </GmapMap>
                </div>
            </div>
        </div>
    </vue-sticky-sidebar>
</template>
<style>
.maps-over-link{
    color: #0f0f0f
}
.maps-over-link.sell:hover{
    color:#fe8a2b
}
.maps-over-link.rent:hover{
    color:#194325
}
.maps-over-link h4{
    color: #0f0f0f
}
.maps-over-link.sell:hover h4{
    color:#fe8a2b
}
.maps-over-link.rent:hover h4{
    color:#194325
}
</style>
<script>
import vueStickySidebar from "vue-sticky-sidebar";
import GmapCluster from "vue2-google-maps/dist/components/cluster"; // replace src with dist if you have Babel issues
import * as VueGoogleMaps from "vue2-google-maps";
export default {
    components: {
        "vue-sticky-sidebar": vueStickySidebar,
        "gmap-cluster": GmapCluster
    },
    created() {},
    mounted() {
        this.init();
        this.screenInit();
        this.markrs();
    },
    data() {
        return {
            t:this.type,
            m: [
                {
                    lat: 10.4578313,
                    lng: -66.5381024,
                    info: "3 bed semi-detached house for sale"
                },
                {
                    lat: -19.85758,
                    lng: -43.9668,
                    info: "2 bed room house for rent"
                },
                {
                    lat: -18.24587,
                    lng: -43.59613,
                    info: "marker 3"
                },
                {
                    lat: -20.46427,
                    lng: -45.42629,
                    info: "marker 4"
                },
                {
                    lat: -20.37817,
                    lng: -43.41641,
                    info: "marker 5"
                },
                {
                    lat: -20.09749,
                    lng: -43.48831,
                    info: "marker 6"
                },
                {
                    lat: -21.13594,
                    lng: -44.26132,
                    info: "marker 7"
                }
            ],
            markers: [],
            center: {
                lat: 10,
                lng: 10
            },
            zoom: 13,
            options: {
                zoomControl: true,
                mapTypeControl: false,
                scaleControl: false,
                streetViewControl: false,
                rotateControl: false,
                fullscreenControl: false,
                disableDefaultUI: false
            },
            infoWindowPos: null,
            infoWinOpen: false,
            currentMidx: null,
            infoOptions: {
                
                //optional: offset infowindow so it visually sits nicely on top of our marker
                pixelOffset: {
                    width: 0,
                    height: -35
                }
            },
            arrow_icon: {
                path:
                    "M50,0C31.294,0,16.129,15.165,16.129,33.87c0,0.401,0.012,0.809,0.03,1.221c0.127,3.558,0.798,6.975,1.939,10.172  C25.324,69.015,50,100,50,100s24.673-30.982,31.9-54.734c1.143-3.197,1.813-6.617,1.939-10.175c0.02-0.412,0.031-0.819,0.031-1.221  C83.871,15.165,68.706,0,50,0z M50,50.459c-9.161,0-16.589-7.428-16.589-16.589c0-9.16,7.428-16.588,16.589-16.588  c9.162,0,16.589,7.428,16.589,16.588C66.589,43.031,59.162,50.459,50,50.459z",
                strokeOpacity: 1,
                strokeWeight: 1,
                fillColor: "#fe8a2b",
                fillOpacity: 1,
                rotation: 0,
                scale: 0.4
            }
        };
    },
    props:['type'],
    methods: {
        init() {
            let url = new URL(location.href);
            
            let lat = url.searchParams.get("lat");
            let lng = url.searchParams.get("lng");
            let locat = url.searchParams.get("locality");
            let aa = url.searchParams.get('administrative_area'); 
            let ctr = url.searchParams.get('country'); 
            if(ctr){
                this.zoom = 6;
            }
            if(aa){
                this.zoom = 10;
            }
            if (locat) {
                
                this.zoom=11
            }
            this.center = { lat: Number(lat), lng: Number(lng) };
            console.log(this.center);
        },
        screenInit() {
            $(document).ready(function() {
                function mapWindow() {
                    var windowHeight = $(window).height();
                    var windowWidth = $(window).width();
                    var menuHeight = $("#menu").height();
                    var heightD = windowHeight;
                    if (windowWidth > 767) {
                        $("#map_wrapper").height(heightD);
                    } else {
                        $("#map_wrapper").height("auto");
                    }
                }
                mapWindow();
                $(window).resize(function() {
                    mapWindow();
                });
            });
        },
        async markrs() {
            this.m.forEach((m, k) => {
                let e = {
                    position: { lat: m.lat, lng: m.lng },
                    // infoText: constuctorInfo(m)
                };

                this.markers.push(e);
            });

            console.log(this.markers);
        },
        toggleInfoWindow: function(marker, idx) {
            this.infoWindowPos = marker.position;
            // this.infoOptions.content = marker.infoText;

            //check if its the same marker that was selected if yes toggle
            
            //if different marker set infowindow to open and reset current marker index
            
                this.infoWinOpen = true;
                this.currentMidx = idx;
            
        },
        closeInfoWindow(){
            this.infoWinOpen = false;
                this.currentMidx = null;
            this.infoWindowPos = null;   
        },
        property(id){
            return this.t+'/propertydetails/'+id
        },
        clickInfo(marker, idx) {
            this.center = marker.position;
            this.zoom = 13;
            this.toggleInfoWindow(marker, idx);
        },
        constuctorInfo(m) {}
    },
    computed: {
        google: VueGoogleMaps.gmapApi
    }
};
</script>
